/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Viviane Yang
 *   Co-authors:
 *      ...
 *    TO DO: 
 *
 */

/**
    @file Asteroids2D.h
    @brief Gametype.
    @ingroup Asteroids2D
*/

#ifndef _Asteroids2DStone_H__
#define _Asteroids2DStone_H__

#include "asteroids2D/Asteroids2DPrereqs.h"

#include "worldentities/pawns/Pawn.h"


namespace orxonox
{
    class _Asteroids2DExport Asteroids2DStone : public Pawn
    {
       public:
            Asteroids2DStone(Context* context);
            Asteroids2DStone(Context* c, int sze, Vector3 pos);

            virtual void tick(float dt) override;
            Vector3 randomPosition (float maxwidth, float maxheight);
            Vector3 randomVelocity(float maxspeed);
            virtual int getSize(){ return this->size;}
            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* ownCollisionShape, btManifoldPoint& contactPoint) override;
            virtual void split();
            virtual void damage(float damage, float healthdamage, float shielddamage, Pawn* originator, const btCollisionShape* cs) override;

       private:
          Asteroids2D* getGame();
          WeakPtr<Asteroids2D> game;
       		int size;				// three sizes, 3-> two 2s, 2-> two 1s, 1-> die
       		float width, height;	//field
          float MAX_SPEED = 100;
          float delta = 5;
    };
}

#endif /* _Asteroids2DStone_H__ */
