/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      ...
 *   Co-authors:
 *      ...
 *
 */

#ifndef _AnswerID_H__
#define _AnswerID_H__

#include "DialogPrereqs.h"
#include "core/XMLPort.h"
#include "core/BaseObject.h"
#include "core/CoreIncludes.h"

#include <string>

namespace orxonox{

	/**
	@brief
    container class for answerids in xml

	*/

	class _DialogExport AnswerId : public BaseObject
	{
		public:
			AnswerId(Context* context);
			
			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);

            void setId(const std::string& Id);	//allows to set Id, only use in xmlPort for initializing AnswerIds in lvl files
            const std::string& getId() const;	//allows to get Id, used in xmlPort

		private: 
			std::string id_;	//!< id of one answer
	};
}

#endif
